#pragma once

#include <atlbase.h>


class CDragUtil : public IDataObject,public IDropSource{
	private:
		long refcount;
		int formatNumber;
		FORMATETC* pFormats;
		STGMEDIUM* pStgMediums;
	public:
		CDragUtil (FORMATETC* _pFormats,STGMEDIUM* _pStgMediums, int _formatNumber);    
		virtual ~CDragUtil ();
	public:
		STDMETHODIMP QueryInterface(REFIID classid, void** intf);
		ULONG STDMETHODCALLTYPE AddRef();
		ULONG STDMETHODCALLTYPE Release();
		STDMETHODIMP GetData(/* [unique][in] */ FORMATETC *pformatetcIn,/* [out] */ STGMEDIUM *pmedium);
		STDMETHODIMP GetDataHere(/* [unique][in] */ FORMATETC *pformatetc,/* [out][in] */ STGMEDIUM *pmedium);
		STDMETHODIMP QueryGetData( /* [unique][in] */ FORMATETC *pformatetc);
		STDMETHODIMP GetCanonicalFormatEtc(/* [unique][in] */ FORMATETC *pformatectIn,/* [out] */ FORMATETC *pformatetcOut);
		STDMETHODIMP SetData(/* [unique][in] */ FORMATETC *pformatetc,/* [unique][in] */ STGMEDIUM *pmedium,/* [in] */ BOOL fRelease);
		STDMETHODIMP EnumFormatEtc(/* [in] */ DWORD dwDirection,/* [out] */ IEnumFORMATETC **ppenumFormatEtc);
		STDMETHODIMP DAdvise(/* [in] */ FORMATETC *pformatetc,/* [in] */ DWORD advf,/* [unique][in] */ IAdviseSink *pAdvSink,/* [out] */ DWORD *pdwConnection);
		STDMETHODIMP DUnadvise(/* [in] */ DWORD dwConnection);
		STDMETHODIMP EnumDAdvise(/* [out] */ IEnumSTATDATA **ppenumAdvise);
	public:
		STDMETHODIMP QueryContinueDrag(/* [in] */ BOOL fEscapePressed,/* [in] */ DWORD grfKeyState);
		STDMETHODIMP GiveFeedback(/* [in] */ DWORD dwEffect);
	private:
		int LookupFormatEtc(FORMATETC *pFormatEtc);
	public:
		static DWORD DoDragDrop(CLIPFORMAT cf,HGLOBAL hGLOBAL,DWORD dwOKEffects);
		static DWORD DoDragDropText(const wchar_t* text,DWORD dwOKEffects);
		static DWORD DoDragDropFiles(const wchar_t** pFilePaths,int fileNumber,DWORD dwOKEffects);
		static HGLOBAL Text2HGLOBAL(const wchar_t* text);
		static HGLOBAL FilePaths2HGLOBAL(const wchar_t** pFilePaths,int fileNumber);
};
HGLOBAL DupGlobalMem (HGLOBAL hMem);
